//+------------------------------------------------------------------+
//|                                      DAILY_RANGE_PROJECTIONS.mq4 |
//|                                                     Yuriy Tokman |
//|                                         http://www.mql-design.ru |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman"
#property link      "http://www.mql-design.ru"

#property indicator_chart_window

extern color colir = Gainsboro;
extern int limit = 30;
extern int Style = 2;
extern int Width = 2;

extern string Copyright = "Yuriy Tokman";
extern string ___ = "_";
extern string e_mail = "yuriytokman@gmail.com";
extern string Skype = "yuriy.g.t";

string txt = "DAILY_RANGE_PROJECTIONS ";
color CL[5]={Salmon,Salmon,Salmon,Salmon,PaleGreen};
//string tchar[256];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//   int i;
//   for (i = 0; i < 256; i++) tchar[i] = CharToStr(i);
   GetAv();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   GetDellName (txt);
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   int limits;
   int counted_bars=IndicatorCounted();   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limits=Bars-counted_bars;   
//----
   if(Period()<1440 && limits>0){
    for(int i=limit; i>=0; i--){
    
     double h = iHigh(Symbol(),1440,i+1);
     double l = iLow(Symbol(),1440,i+1);
     double o = iOpen(Symbol(),1440,i+1);
     double c = iClose(Symbol(),1440,i+1);
     
     double x=0;
     if(c<o)       x=(h+l+c+l)/2;
     else if(c>o)  x=(h+l+c+h)/2;
     else if(c==o) x=(h+l)/2;     
     
     h=x-h;
     l=x-l;
                    
     datetime t = iTime(Symbol(),1440,i);
     datetime t_a = 1440*60;    
     string tx = TimeToStr(t,TIME_DATE );       

     TrendLineGraff(txt+tx+" l",t,h,t,l);
     TrendLineGraff(txt+tx+" k",t+t_a,h,t+t_a,l);     
     TrendLineGraff(txt+tx+" h",t,h,t+t_a,h);
     TrendLineGraff(txt+tx+" w",t,l,t+t_a,l);
     TrendLineGraff(txt+tx+" q",t,c,t+t_a,c);                         
   }}  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                             |
//| :                                                |
//| e-mail: yuriytokman@gmail.com                                    |
//| ICQ#    481-971-287                                              |
//| Skype:  yuriy.g.t                                                |
//+------------------------------------------------------------------+
 void GetDellName (string name_n = "ytg_")
  {
   string vName;
   for(int i=ObjectsTotal()-1; i>=0;i--)
    {
     vName = ObjectName(i);
     if (StringFind(vName,name_n) !=-1) ObjectDelete(vName);
    }  
  }
//+------------------------------------------------------------------+
//|                                  |
//| :                                                |
//| e-mail: yuriytokman@gmail.com                                    |
//| ICQ#    481-971-287                                              |
//| Skype:  yuriy.g.t                                                |
//+------------------------------------------------------------------+
 void TrendLineGraff(string labebe,datetime time1,double price1,datetime time2,double price2)
  {
   if (ObjectFind(labebe)!=-1) ObjectDelete(labebe);
   ObjectCreate(labebe, OBJ_TREND, 0,time1,price1,time2,price2);
   ObjectSet(labebe, OBJPROP_COLOR, colir);
   ObjectSet(labebe, OBJPROP_STYLE,Style);
   ObjectSet(labebe, OBJPROP_RAY,false);
   ObjectSet(labebe, OBJPROP_BACK, true);
   ObjectSet(labebe, OBJPROP_WIDTH,Width);   
  }
//----
void GetAv()
 {
  string tchar[256]; int i;
  for (i = 0; i < 256; i++) tchar[i] = CharToStr(i);   
  string txtt = tchar[70]+tchar[97]+tchar[99]+tchar[116]+tchar[111]+tchar[114]+tchar[121]+tchar[32]
  +tchar[111]+tchar[102]+tchar[32]+tchar[116]+tchar[104]+tchar[101]+tchar[32]+tchar[97]
  +tchar[100]+tchar[118]+tchar[105]+tchar[115]+tchar[101]+tchar[114]+tchar[115]+tchar[58]
  +tchar[32]+tchar[121]+tchar[117]+tchar[114]+tchar[105]+tchar[121]+tchar[116]+tchar[111]
  +tchar[107]+tchar[109]+tchar[97]+tchar[110]+tchar[64]+tchar[103]+tchar[109]+tchar[97]
  +tchar[105]+tchar[108]+tchar[46]+tchar[99]+tchar[111]+tchar[109];Label("ytg_321",txtt,2,3,15,10);  
 }
//----
 void Label(string name_label,string text_label,int corner = 2,int x = 3,int y = 15,int font_size = 10,string font_name = "Arial",color text_color = LimeGreen )
  {
   if (ObjectFind(name_label)!=-1) ObjectDelete(name_label);
       ObjectCreate(name_label,OBJ_LABEL,0,0,0,0,0);         
       ObjectSet(name_label,OBJPROP_CORNER,corner);
       ObjectSet(name_label,OBJPROP_XDISTANCE,x);
       ObjectSet(name_label,OBJPROP_YDISTANCE,y);
       ObjectSetText(name_label,text_label,font_size,font_name,text_color);
  }